#!/usr/bin/env ruby

DB_FILE_PATH="/iPod_Control/iTunes/iTunesDB"

MHBD=[109,104,98,64]
MHSD=[109,104,115,64]
MHLT=[109,104,108,116]
MHIT=[109,104,105,116]
MHOD=[109,104,111,100]
MHLP=[109,104,108,112]
MHYP=[109,104,121,112]
MHIP=[109,104,105,112]

MHOD_TYPE=[]
MHOD_TYPE[1]  = "Title"
MHOD_TYPE[2]  = "Location"
MHOD_TYPE[3]  = "Album"
MHOD_TYPE[4]  = "Artist"
MHOD_TYPE[5]  = "Genre"
MHOD_TYPE[6]  = "Filetype"
MHOD_TYPE[7]  = "EQ Setting"
MHOD_TYPE[8]  = "Comment"
MHOD_TYPE[12] = "Composer"
MHOD_TYPE[13] = "Grouping"
MHOD_TYPE[50] = "Smart Playlist Data"
MHOD_TYPE[51] = "Smart Playlist Rules"
MHOD_TYPE[52] = "Library Playlist Index"
MHOD_TYPE[100]= "100"

class Ring
	RINGSIZE=4
	def initialize
		@a=[0,0,0,0]
	end
	def push(data)
		@a[0]=@a[1]
		@a[1]=@a[2]
		@a[2]=@a[3]
		@a[3]=data
	end
	def get
		@a
	end
end

class Array
	def getbyte(start_p,size)
		byte=0
		0.upto(size-1) do |i|
			byte+=self[start_p+i]*(0x100**(i))
		end
		byte
	end

	def getstring(start_p,size)
		@data=[]
		0.upto((size-1)/2) do |i|
			@data.push self[start_p+i*2]+self[start_p+i*2+1]*0x100
		end
		@data.pack("U*")
	end

	def find(start_p,size,pattern)
		r=Ring.new
		p=[]
		index=start_p
		arr_size=self.size
		self[start_p...arr_size-1].each do |a|
			r.push a
			if r.get==pattern
				p.push index-3
				if p.size==size
					break
				end
			end
			index+=1
		end
		p
	end

	def find_all(pattern)
		r=Ring.new
		p=[]
		index=0
		self.each do |a|
			r.push a
			if r.get==pattern
				p.push index-3
			end
			index+=1
		end
		p
	end
	
end

class ITunesDB
	def initialize(path)
		path+=DB_FILE_PATH
		fp=open(path,"rb")
		@arr=[]
		fp.each_byte do |byte|
			@arr.push byte
		end
	end


	def get_songs
		pmhit=@arr.find_all(MHIT)
		songs=Hash.new
		pmhod=[]

		pmhit.each do |mhit_head|
			number_of_strings = @arr.getbyte(mhit_head+12,4)
			unique_id         = @arr.getbyte(mhit_head+16,4)
			length_of_track   = @arr.getbyte(mhit_head+40,4)
			pmhod = @arr.find(mhit_head,number_of_strings,MHOD)
			mhods = Hash.new
			pmhod.each do |mhod_head|
				type   = @arr.getbyte(mhod_head+12,1)
				length = @arr.getbyte(mhod_head+28,4)
				mhods[MHOD_TYPE[type]]=
					@arr.getstring(mhod_head+40,length)
			end
			mhods["Length"]=length_of_track
			songs[unique_id]=mhods
		end
		songs
	end

	def get_playlists
		pmhyp=@arr.find_all(MHYP)
		songlists=[]
		pmhod=[]
		songlist=Hash.new
		pmhyp.each do |mhyp_head|
			data_object_child_count = @arr.getbyte(mhyp_head+12,4)
			playlist_item_count = @arr.getbyte(mhyp_head+16,4)
			playlist_id_number  = @arr.getbyte(mhyp_head+28,4)
			pmhod = @arr.find(mhyp_head,data_object_child_count,MHOD)
			pmhip = @arr.find(mhyp_head,playlist_item_count,MHIP)

			mhods = Hash.new
			pmhod.each do |mhod_head|
				type   = @arr.getbyte(mhod_head+12,1)
				length = @arr.getbyte(mhod_head+28,4)
				mhods[MHOD_TYPE[type]]=
					@arr.getstring(mhod_head+40,length)

			end
			track_id=[]
			pmhip.each do |mhip_head|
				track_id.push @arr.getbyte(mhip_head+24,4)
			end
			songlist["Title"]=mhods["Title"]
			songlist["SongList"]=track_id
			
			songlists.push songlist
		end
		songlists
		
	end

end
